Bug 509052 - Invalid free with abe -t
Summary: Invalid free with abe -t
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: abe
Version: 13
Hardware: x86_64
OS: Linux
low
medium
Target Milestone: ---
Assignee: Wart
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2009-07-01 03:05 UTC by Jerry James
Modified: 2011-05-09 13:59 UTC (History)
2 users (show)

Fixed In Version: abe-1.1-12.fc14
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2011-03-19 05:48:53 UTC
Type: ---


Attachments (Terms of Use)

Description Jerry James 2009-07-01 03:05:32 UTC
Description of problem:
I'm having non-abe-specific problems with games that try to use low video modes, probably due to the kernel modesetting work.  I ran "abe -t" to find out what modes abe thinks it can use, so I can select one that works.  I got a list of modes, followed by this:

*** glibc detected *** abe: free(): invalid pointer: 0x0000003157b69ed8 ***
======= Backtrace: =========
/lib64/libc.so.6[0x3157875a26]
/usr/lib64/libSDL-1.2.so.0[0x3f1443ee15]
/usr/lib64/libSDL-1.2.so.0[0x3f144413ef]
/usr/lib64/libSDL-1.2.so.0(SDL_VideoQuit+0x42)[0x3f1442fe12]
/usr/lib64/libSDL-1.2.so.0(SDL_QuitSubSystem+0x45)[0x3f144082b5]
/usr/lib64/libSDL-1.2.so.0(SDL_Quit+0xe)[0x3f1440834e]
/lib64/libc.so.6(exit+0xe2)[0x31578367f2]
abe[0x406e0d]
/lib64/libc.so.6(__libc_start_main+0xfd)[0x315781ea2d]
abe[0x401999]

That is followed by a (long) memory map, which I can attach if it is helpful.

Version-Release number of selected component (if applicable):
abe-1.1-10.fc11.x86_64

How reproducible:
Always

Steps to Reproduce:
1. abe -t

Actual results:
Glibc reports free() of an invalid pointer.

Expected results:
Normal exit.

Additional info:

Comment 1 Wart 2009-07-01 03:16:53 UTC
Thanks for the report.  I'm able to reproduce this locally as well.  I'll take some time offline to try to diagnose this.

Comment 2 Bug Zapper 2010-04-27 15:23:22 UTC
This message is a reminder that Fedora 11 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 11.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '11'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 11's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 11 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping

Comment 3 Wart 2010-04-27 16:01:09 UTC
Refiling against F13 so that it doesn't get lost.

Comment 4 Jerry James 2011-02-25 02:33:51 UTC
I looked at this today.  The problem is that the function testModesInFormat() in src/Main.c calls SDL_ListModes(), then passes the result of that function to free().  However, SDL_ListModes() returns a pointer to internal SDL storage.  Just get rid of the line:

  free(modes);

on line 39 of Main.c and this problem will go away.

Comment 5 Fedora Update System 2011-03-14 17:42:51 UTC
abe-1.1-12.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/abe-1.1-12.fc14

Comment 6 Fedora Update System 2011-03-14 17:42:59 UTC
abe-1.1-13.fc15 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/abe-1.1-13.fc15

Comment 7 Fedora Update System 2011-03-14 17:43:06 UTC
abe-1.1-12.fc13 has been submitted as an update for Fedora 13.
https://admin.fedoraproject.org/updates/abe-1.1-12.fc13

Comment 8 Fedora Update System 2011-03-19 05:48:46 UTC
abe-1.1-13.fc15 has been pushed to the Fedora 15 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 9 Fedora Update System 2011-03-23 22:49:29 UTC
abe-1.1-12.fc13 has been pushed to the Fedora 13 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 10 Fedora Update System 2011-03-23 22:50:57 UTC
abe-1.1-12.fc14 has been pushed to the Fedora 14 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.